

local t = TRCLOOT 
--[[
--     CHAT_MSG_LOOT
]]--

local chatMsgLootFrame = CreateFrame("Frame")
chatMsgLootFrame:RegisterEvent("CHAT_MSG_LOOT")
chatMsgLootFrame:SetScript("OnEvent", function(self, event, ...)
    --if event == "CHAT_MSG_LOOT" then 
    --[[ CHAT MSG LOOT ]]--

    local t = TRCLOOT

    local message, sender, language, channelString, target, flags, _, channelNumber, channelName, _, counter = ...


    -- If ML is on, this means you've already been assigned the loot, so dont offer it.
    if GetLootMethod() == "master" then
        return
    end





    -- Captures:   1 person/You, 2 itemstring, 3 rest of string after final |r until '.'
    -- Can change 'loot' to 'item' to trigger on, e.g., extracting stuff from mail
    local loot_pattern = "(%S+) receives? loot:.*|cff%x+|H(.-)|h.*|r(.*)%.$"


    -- CHAT_MSG_LOOT handler
    local msg =  message
    local person, itemstring, remainder = msg:match(loot_pattern)
    local count = remainder and remainder:match(".*(x%d+)$")

    if not person then return end    -- "So-and-So selected Greed", etc, not actual looting


    -- Name might be colorized, remove the highlighting
    local p = person:match("|c%x%x%x%x%x%x%x%x(%S+)")
    person = p or person
    if person ~= UNIT_YOU then
        return
    end


    -- If it is armor
    local itemType = select(6, GetItemInfo(itemstring))
    if (itemType and (itemType == "Armor")) or IsArtifactRelicItem(itemstring) then

        -- Store the id so that we can use it in
        -- the BAG_UPDATE event handler
        --local itemID = tonumber((select(2, strsplit(":", itemstring))))
        --local bonusID = tonumber((select(11, strsplit(":", itemstring))))
        local itemID, nBonus, bonus1, bonus2, bonus3 = t.getBonusIDs(itemstring)
        --local bonusString = (bonus1 or "")..":"..(bonus2 or "")..":"..(bonus3 or "")
        local bonusString = t.mergeBonusIDs(nBonus, bonus1, bonus2, bonus3)

        t.itemsLooted = t.itemsLooted or {}
        table.insert(t.itemsLooted, {id=itemID, bonus=bonusString, expires=GetTime()+10})


    end
end)



-- Tooltip scanning misc
t.setBagItemToTooltip = function(d, callback)
   local tooltipName = "RavenCouncil_BagItemScanningTooltip"
   t.bagScanTooltip = t.bagScanTooltip or CreateFrame("GameTooltip", tooltipName, UIParent, "GameTooltipTemplate")

   t.bagScanQueue = t.bagScanQueue or {}

  
   table.insert(t.bagScanQueue, {d=d, callback=callback})

   t.scanBagNextInQueue()
end


t.scanBagNextInQueue = function()
    local tooltipName = "RavenCouncil_BagItemScanningTooltip"

    if t.currentlyScanningBag == nil then
        t.currentlyScanningBag = false
    end

    if (not t.currentlyScanningBag) and ((#t.bagScanQueue) > 0) then
        t.currentlyScanningBag = true

        local data = table.remove(t.bagScanQueue, 1)

        t.bagScanTooltip:ClearLines()
        t.bagScanTooltip:SetOwner(UIParent, "ANCHOR_NONE")
        t.bagScanTooltip:SetScript("OnUpdate", function()
            if (_G[tooltipName.."TextLeft1"]:GetText() ~= "Retrieving item information")  then
                t.bagScanTooltip:SetScript("OnUpdate", nil)
                data.callback(data.d.bag, data.d.slot, data.d.id, data.d.bonus, data.d.n)
                t.currentlyScanningBag = false
                t.scanBagNextInQueue()

            end
        end)
        t.bagScanTooltip:SetBagItem(data.d.bag, data.d.slot)
    end
end




t.offerIfTradable = function(bag, slot, id, bonus, queueIndex)
    local tooltipName = "RavenCouncil_BagItemScanningTooltip"


    for n=1, t.bagScanTooltip:NumLines() do
        local line = _G[tooltipName.."TextLeft"..n]:GetText()
        if string.find(line, "You may trade this item with players that were also eligible to loot this item for the next") then
            -- If tradable
            local hyperlink = GetContainerItemLink(bag, slot)
            t.offerLoot(hyperlink, false, nil)

            -- Schedule it to be removed from the queue
            t.itemsLooted[queueIndex].expires = -11 -- this will surely be smaller than the current time, so it will be removed from the queue during the next scan

            local m=1
            while m <= #t.bagScanQueue do
                if (t.bagScanQueue[m].d.id == id) and (t.bagScanQueue[m].d.bonus == bonus) then
                    table.remove(t.bagScanQueue, m)
                else
                    m=m+1
                end
            end

            return true
        end
    end

    if t.itemsLooted[queueIndex].expires < GetTime() then
        t.itemsLooted[queueIndex].expires = -11

        local m=1
        while m <= #t.bagScanQueue do
            if (t.bagScanQueue[m].d.id == id) and (t.bagScanQueue[m].d.bonus == bonus) then
                table.remove(t.bagScanQueue, m)
            else
                m=m+1
            end
        end
    end

    local hyperlink = GetContainerItemLink(bag, slot)

    -- If not tradable
    --[[if t.getVar("compareNonTradable") then
        local hyperlink = GetContainerItemLink(bag, slot)
        t.offerLoot(hyperlink, true, nil)
    end
    ]]--


    return false

end



local scanBagsForTradable = function(self, event, ...)

    local t = TRCLOOT

    t.itemsLooted = t.itemsLooted or {}

    local currentTime = GetTime()
    -- If there is an item looted but not yet found in bags
    if next(t.itemsLooted) then
        -- Scan bags for the item based on item id
        -- for every bag
        for bag=0, 5 do
            -- for everty item in the bag
            for slot=0, GetContainerNumSlots(bag) do
                local bagLink = GetContainerItemLink(bag, slot)
                if bagLink then
                    local bagId, nBonus, bonus1, bonus2, bonus3 = t.getBonusIDs(bagLink)
                    local bagBonus = t.mergeBonusIDs(nBonus, bonus1, bonus2, bonus3)
                    --local bagBonus = (bonus1 or "")..":"..(bonus2 or "")..":"..(bonus3 or "")
                    --local bagId = tonumber((select(2, strsplit(":", bagLink))))
                    --local bagBonus = tonumber((select(11, strsplit(":", bagLink))))

                    -- For every item in the queue
                    local n = 1 
                    while n <= #t.itemsLooted do
                        -- If we found an item
                        local id = t.itemsLooted[n].id
                        local bonus = t.itemsLooted[n].bonus
                        local expires = t.itemsLooted[n].expires


                        if (currentTime < expires) and (id == bagId) and (bonus == bagBonus) then
                            -- Offer it if it's tradable
                            t.setBagItemToTooltip({bag=bag, slot=slot, n=n, id=id, bonus=bonus}, t.offerIfTradable)
                        elseif currentTime >= expires+10 then
                            t.itemsLooted[n].expires = -11
                        end
                        n = n+1
                    end 
                end    
            end

            -- Decrement all counters. If counter reaches 0, remove it from the queue.

            local n = 1
            while n <= #t.itemsLooted do
                if t.itemsLooted[n].expires == -11 then
                    table.remove(t.itemsLooted, n)
                else
                    n = n+1
                end
            end

        end
    end
end

--[[
--     BAG_UPDATE
]]--
local bagUpdateFrame = CreateFrame("Frame")
bagUpdateFrame:RegisterEvent("BAG_UPDATE")
bagUpdateFrame:SetScript("OnEvent", scanBagsForTradable)

--[[
--     Every second
]]--
local everySecondFrame = CreateFrame("Frame");
function everySecondFrame:onUpdate(sinceLastUpdate)
	self.sinceLastUpdate = (self.sinceLastUpdate or 0) + sinceLastUpdate;
	self.sinceLastUpdate10 = (self.sinceLastUpdate10 or 0) + sinceLastUpdate;

	if ( self.sinceLastUpdate >= 2 ) then -- in seconds
        scanBagsForTradable()
		self.sinceLastUpdate = 0
	end

    if ( self.sinceLastUpdate10 >= 10 ) then

        t.scanInventoryForTier()
        t.scanBagsForTier()
        t.scanBankForTier()
        self.sinceLastUpdate10 = 0
    end
end
everySecondFrame:SetScript("OnUpdate",everySecondFrame.onUpdate)


--[[
--     BANK OPEN
]]--
local bankOpenFrame = CreateFrame("Frame")
bankOpenFrame:RegisterEvent("BANKFRAME_OPENED")
bankOpenFrame:SetScript("OnEvent", function()
    t.scanBankForTier()
end)



--[[
--     CHAT_MSG_ADDON
]]--

local chatMsgAddonFrame = CreateFrame("Frame")
chatMsgAddonFrame:RegisterEvent("CHAT_MSG_ADDON")
chatMsgAddonFrame:SetScript("OnEvent", function(self, event, ...)
    local t = TRCLOOT

    TRCLOOT.messages = TRCLOOT.messages or {}
    local messages = TRCLOOT.messages


    local prefix, msg, channel, sender = ...
    -- If msg for our addon
    if prefix == t.ADDON_MESSAGE_PREFIX then

        -- Obtain and remove prefix from msg
        local prefix = msg:sub(1,1)
        msg = msg:sub(2)

        -- Append message to current msg
        messages[sender] = (messages[sender] or "")..msg

        --If this is the last chunk, process it.
        if prefix == t.MSG_DONE then

            msg = messages[sender]
            -- Set to nil for next message
            messages[sender] = nil

            -- Deserialize the msg
            t.libS = t.libS or LibStub:GetLibrary("AceSerializer-3.0")

            local success, data = t.libS:Deserialize(msg)
            if not success then
                print(t.MSG_PREFIX.."Something went wrong communicating. You might have to /reload, sorry :(")
                return
            end

            -- Process the msg
            if data.type == t.OFFER then
                local hyperlink = data.hyperlink

                local origin = data.origin or sender
                t.storeItem(hyperlink, origin)

                local specInfo = t.getVar("specs")
                for n=1, GetNumSpecializations() do
                    if specInfo[n]["enable"] then
                        t.calculateUpgradeScore(hyperlink, origin, n, data.selfOnly)
                    end
                end
                t.drawReports()
            elseif data.type == t.REPORT then
                data.sender = sender
                t.storeReport(data)
                t.drawReports()
            elseif data.type == t.VERSION_REQUEST then
                t.respondToVersionRequest(sender)
            elseif data.type == t.VERSION_RESPONSE then
                t.versionInfo = t.versionInfo or {}
                t.versionInfo[Ambiguate(sender, "short")] = data.versionNumber
            end

        end


    end
end)




--[[
--     ITEM INFO RECEIVED
]]--

local itemInfoReceivedFrame = CreateFrame("Frame")
itemInfoReceivedFrame:RegisterEvent("GET_ITEM_INFO_RECEIVED")
itemInfoReceivedFrame:SetScript("OnEvent", function(self, event, ...)
    --elseif event == "GET_ITEM_INFO_RECEIVED" then

    --[[ ITEM INFO RECEIVED ]]-- 
    -- GetItemInfo will return nil if the item is not currently loaded in memory.
    -- Whenever the item gets loaded, GET_ITEM_INFO_RECEIVED event will be thrown.
    -- This piece of code responds to that event by checking if it was the item 
    -- we were trying to call GetItemInfo() on, and if so calls a callback function.

    local t = TRCLOOT
    -- If we were waiting for items to load, loop over them
    if t.itemInfoQueue then
        local n = 1
        while n <= #t.itemInfoQueue do
        --for n, item in pairs(t.itemInfoQueue) do
            local item = t.itemInfoQueue[n]


            -- Deeply ashamed by this code, but hey, it works.
            local itemToCheck
            local itemToCheck2
            if (item.callback == t.calculateUpgradeScoreCallback) or (item.callback == t.calculateUpgradeScore) then
                itemToCheck = item.item
            else
                itemToCheck = item.equipedItem
                itemToCheck2 = item.equipedItem2
            end


            if GetItemInfo(itemToCheck) and
                ((not itemToCheck2) or (itemToCheck2 and GetItemInfo(itemToCheck2))) then


                -- Shame intensifies.
                if item.callback == t.calculateUpgradeScoreCallback then
                    item.callback(item.item, item.origin, item.spec, selfOnly, item.originalItem)
                elseif item.callback == t.calculateUpgradeScoreCallback2 then
                    item.callback(item.item, item.equipedItem, item.equipedItem2, item.origin, item.spec, selfOnly, item.originalItem)
                elseif item.callback == t.calculateUpgradeScore then
                    item.callback(item.item, item.origin, item.spec, item.selfOnly)
                end

                table.remove(t.itemInfoQueue, n)
            else
                n = n + 1
            end
        end
    end
end)





--[[
--     ADDON LOADED
]]--

local addonLoadedFrame = CreateFrame("Frame")
addonLoadedFrame:RegisterEvent("ADDON_LOADED")
addonLoadedFrame:SetScript("OnEvent", function(self, event, addon)
    local t = TRCLOOT

    if addon == t.ADDON_NAME then
        if RavenLoot_svc == nil then
            RavenLoot_svc = {}
        end

        t.svc = RavenLoot_svc


        -- Set default stat weights if no stat weigths
        if not t.svc.statWeights then
            t.svc.defaultWeights = true
            t.svc.statWeights = t.defaultStatWeights
        end

        -- Old option, should be disabled for everyone.
        t.svc["reportAllEquipable"] = false


    end


end)

--[[
--     PLAYER ENTERIGN WORLD
]]--

local playerEnteringWorldFrame = CreateFrame("Frame")
playerEnteringWorldFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
playerEnteringWorldFrame:SetScript("OnEvent", function(self, event, addon)

    local t = TRCLOOT
    local specs = t.getVar("specs")
    for n=1, GetNumSpecializations() do
        -- Load primary stats
        local primaryCode = select(6, GetSpecializationInfo(n))

        local primaryStat
        if primaryCode == LE_UNIT_STAT_STRENGTH then
            primaryStat = "ITEM_MOD_STRENGTH_SHORT"
        elseif primaryCode == LE_UNIT_STAT_INTELLECT then
            primaryStat = "ITEM_MOD_INTELLECT_SHORT"
        elseif primaryCode == LE_UNIT_STAT_AGILITY then
            primaryStat = "ITEM_MOD_AGILITY_SHORT"
        else
            print(t.MSG_PREFIX.."Unknown primary stat "..primaryCode..". Please report this issue to the author.")
            return
        end

        specs[n].primary = primaryStat




        --[[
        -- Set equipmentSet
        if not specs[n].equipmentSet then
            specs[n].equipmentSet = GetEquipmentSetInfo(1)
        end
        ]]--

        local lastRunBuild = t.getVar("build")
        if lastRunBuild < 70200 then -- Patch 7.2
            print(t.MSG_PREFIX.."Equipment sets have been reset. Please reselect them in the Raven Loot options or assign a set to a spec in the Blizzard Equipment Manager.")
            if specs[1] then specs[1].equipmentSet = -1 end
            if specs[2] then specs[2].equipmentSet = -1 end
            if specs[3] then specs[3].equipmentSet = -1 end
            if specs[4] then specs[4].equipmentSet = -1 end

            local currentBuild = select(4, GetBuildInfo())
            t.setVar("build", currentBuild)
        end

    end



    -- Initialize tier token list based on tierIDs in tier.lua
    t.tierWatchlist = t.tierWatchList or {}
    local class = select(2, UnitClass("player"))

    for tokenID, to in pairs(t.tierIDs) do

        local itemID = to[class]

        if itemID then
            t.tierWatchlist[itemID] = true
        end
    end

    t.scanInventoryForTier()
    t.scanBagsForTier()
    t.scanBankForTier()


end)



StaticPopupDialogs["TRCLOOT_OFFER_ML"] = {
   text = t.MSG_PREFIX.."Do you want to offer this loot?",
   button1 = "Yes",
   button2 = "No",
   OnAccept = function()

       for n=1, GetNumLootItems() do
           local quality = select(4, GetLootSlotInfo(n))
           local threshold = t.getVar("mlThreshold")

           if quality >= threshold then
               local item = GetLootSlotLink(n)
               t.offerLoot(item, false, "Master Loot")
           end
       end

   end,
   timeout = 0,
   whileDead = true,
   hideOnEscape = true,
   preferredIndex = 3,  -- avoid some UI taint, see http://www.wowace.com/announcements/how-to-avoid-some-ui-taint/
}


--[[ 
--LOOT CLOSED
-- ]]--
local lootClosedFrame = CreateFrame("Frame")
lootClosedFrame:RegisterEvent("LOOT_CLOSED")
lootClosedFrame:SetScript("OnEvent", function(self, event, ...)

    t.lootOpen = false
end)

--[[ 
--LOOT OPENED
-- ]]--
local lootOpenedFrame = CreateFrame("Frame")
lootOpenedFrame:RegisterEvent("LOOT_OPENED")
lootOpenedFrame:SetScript("OnEvent", function(self, event, ...)

    t.lootOpen = true

    if GetLootMethod() == "master" and IsMasterLooter("player") then
        local meetsQualityTreshold = false
        local treshold = t.getVar("mlThreshold")
        local lootInfo = GetLootInfo()

        for _, item in pairs(lootInfo) do
            if item.quality >= treshold then
                meetsQualityTreshold = true
            end
        end

        if meetsQualityTreshold then
            StaticPopup_Show("TRCLOOT_OFFER_ML")
        end
    end
    

end)
